import { Comparator } from '../types';
import { BaseCollection } from './base-collection';
export interface Set<T> {
    insert(element: T): void;
    insertList(elements: T[]): void;
    remove(element: T): void;
    find(element: T): boolean;
    forEach(callback: (element: T) => void): void;
}
export declare class Set<T> extends BaseCollection<T> implements Set<T> {
    private bst;
    constructor(comparator?: Comparator<T>);
    /**
     * Removes all elements from the set
     */
    clear(): void;
    /**
     * Returns true if the set contains no elements
     */
    isEmpty(): boolean;
    /**
     * Returns the number of elements in the set
     */
    size(): number;
}
